package de.uni_passau.fim.PADAS.group3.DataDash.controler;

import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.web.bind.annotation.*;

import de.uni_passau.fim.PADAS.group3.DataDash.model.Dataset;
import de.uni_passau.fim.PADAS.group3.DataDash.model.DatasetService;
import de.uni_passau.fim.PADAS.group3.DataDash.model.Type;
import java.util.List;
import java.util.UUID;
import org.springframework.web.bind.annotation.PostMapping;
import org.springframework.web.bind.annotation.RequestBody;





@RestController
@RequestMapping("/api/v1/datasets")
public class DatasetController {
    @Autowired
    private DatasetService datasetService;
    
    @GetMapping
    public List<Dataset> getAllDatasets() {
        return datasetService.getAllDatasets();
    }
    
    @GetMapping("/id/{id}")
    public Dataset getDatasetById(@PathVariable("id") UUID id) {
        return datasetService.getDatasetById(id);
    }
    
    @PostMapping
    public Dataset createDataset(@RequestBody Dataset dataset) {
        datasetService.addDataset(dataset);
        //TODO: figure out what the fuck i need to do here 
        return null;
    }
    
    //@PutMapping("/{id}")
    //public Dataset updateDataset(@PathVariable("id") Long id, @RequestBody Dataset dataset) {
    //    return datasetService.updateDataset(id, dataset);
    //}
    //

    @DeleteMapping("/id/{id}")
    public void deleteDataset(@PathVariable("id") UUID id) {
        datasetService.deleteDataset(id);
    }

    @GetMapping("/title/{title}")
    public List<Dataset> getByTitle(@PathVariable("title") String title) {
        return datasetService.getDatasetsByTitleLike(title);
    }

    @GetMapping("/description/{description}")
    public List<Dataset> getbyDescription(@PathVariable("description") String description) {
        return datasetService.findByDescriptionLike(description);
    }

    @GetMapping("/author/{author}")
    public List<Dataset> getByAuthor(@PathVariable("author") String author) {
        return datasetService.getDatasetsByAuthorLike(author);
    }
    
    @GetMapping("/abst/{abst}")
    public List<Dataset> getByAbstract(@PathVariable("abst") String abst) {
        return datasetService.getDatasetsByAbstLike(abst);
    }

    @GetMapping("/type/{type}")
    public List<Dataset> getByType(@PathVariable("type") Type type) {
        return datasetService.getDatasetsByType(type);
    }

    @GetMapping("/rating/{rating}")
    public List<Dataset> getByType(@PathVariable("rating") float rating) {
        return datasetService.getDatasetsByRaitingGreaterThan(rating);
    }

    @PostMapping("/id/{id}/upvote")
    public Dataset upvote(@PathVariable("id") UUID id) {
        datasetService.upvoteDataset(id);        
        return null;
    }

    @PostMapping("/id/{id}/downvote")
    public Dataset downvote(@PathVariable("id") UUID id) {
        datasetService.downvoteDataset(id);
        return null; //new ResponseEntity<>(null, HttpStatus.OK);
    }


}